context("test-misc")

test_that("get_ratio() works", {

  expect_identical(get_ratio("16by9"), 16 / 9)
  expect_identical(get_ratio("4by3"), 4 / 3)

  expect_error(get_ratio("foo"), "should be one of")
})

test_that("get_width_height() works", {

  expect_identical(
    get_width_height(width = 500, height = 300, ratio = "16by9"),
    list(width = 500, height = 300)
  )

  expect_identical(
    get_width_height(width = NULL, height = 300, ratio = "16by9"),
    list(width = 533, height = 300)
  )

  expect_identical(
    get_width_height(width = 533, height = NULL, ratio = "16by9"),
    list(width = 533, height = 300)
  )



})

context("test-iframe")

emb_youtube <- rickroll_youtube()
emb_vimeo <- rickroll_vimeo()

iframe_youtube <- get_iframe(emb_youtube)

test_that("getting an iframe works", {
  expect_is(iframe_youtube, "shiny.tag")
  expect_identical(iframe_youtube$name, "iframe")
})

test_that("setting an iframe works", {

  emb_youtube_new <- set_iframe(emb_vimeo, iframe_youtube)

  expect_identical(get_iframe(emb_youtube_new), iframe_youtube)
})

context("suggest")

####
url_youtube <- "https://www.youtube.com/watch?v=1-vcErOPofQ"

list_parse_youtube <- list(
  service = "youtube",
  id = "1-vcErOPofQ",
  start_time = NULL
)

list_suggest_youtube <- list(
  embed = "embed_youtube(\"1-vcErOPofQ\")",
  start_time = NULL
)

####
url_youtube_short_time <- "https://youtu.be/1-vcErOPofQ?t=28s"

list_parse_youtube_short_time <- list(
  service = "youtube",
  id = "1-vcErOPofQ",
  start_time = "28s"
)

list_suggest_youtube_short_time <- list(
  embed = "embed_youtube(\"1-vcErOPofQ\")",
  start_time = "use_start_time(\"28s\")"
)

####
url_vimeo_time <- "https://vimeo.com/131407894#t=6s"

list_parse_vimeo_time <- list(
  service = "vimeo",
  id = "131407894",
  start_time = "6s"
)

list_suggest_vimeo_time <- list(
  embed = "embed_vimeo(\"131407894\")",
  start_time = "use_start_time(\"6s\")"
)

####
url_channel9 <- "https://channel9.msdn.com/Shows/Going+Deep/Brian-Beckman-Dont-fear-the-Monads"

list_parse_channel9 <- list(
  service = "channel9",
  id = "Shows/Going+Deep/Brian-Beckman-Dont-fear-the-Monads",
  start_time = NULL
)

list_suggest_channel9 <- list(
  embed = "embed_channel9(\"Shows/Going+Deep/Brian-Beckman-Dont-fear-the-Monads\")",
  start_time = NULL
)

####
url_user2016 <- "https://channel9.msdn.com/Events/useR-international-R-User-conference/useR2016/Day-3-Siepr-130-Ligtning-Talks-100-PM-140-PM?ocid=player"

list_parse_user2016 <- list(
  service = "user2016",
  id = "Day-3-Siepr-130-Ligtning-Talks-100-PM-140-PM",
  start_time = NULL
)

list_suggest_user2016 <- list(
  embed = "embed_user2016(\"Day-3-Siepr-130-Ligtning-Talks-100-PM-140-PM\")",
  start_time = NULL
)

url_user2017 <- "https://channel9.msdn.com/Events/useR-international-R-User-conferences/useR-International-R-User-2017-Conference/Room-202-Lightning-Talks"

list_parse_user2017 <- list(
  service = "user2017",
  id = "Room-202-Lightning-Talks",
  start_time = NULL
)

list_suggest_user2017 <- list(
  embed = "embed_user2017(\"Room-202-Lightning-Talks\")",
  start_time = NULL
)

####
url_box <- "https://app.box.com/s/m5do45hvzw32iv2aors3urf5pgkxxazx"
url_box_acme <- "https://acme.app.box.com/s/m5do45hvzw32iv2aors3urf5pgkxxazx"

list_parse_box <- list(
  service = "box",
  id = "m5do45hvzw32iv2aors3urf5pgkxxazx",
  custom_domain = NULL,
  start_time = NULL
)

list_parse_box_acme <- list(
  service = "box",
  id = "m5do45hvzw32iv2aors3urf5pgkxxazx",
  custom_domain = "acme",
  start_time = NULL
)

list_suggest_box <- list(
  embed = 'embed_box("m5do45hvzw32iv2aors3urf5pgkxxazx")',
  start_time = NULL
)

list_suggest_box_acme <- list(
  embed = 'embed_box("m5do45hvzw32iv2aors3urf5pgkxxazx", custom_domain = "acme")',
  start_time = NULL
)

####
url_msstream <-
  "https://web.microsoftstream.com/video/ae21b0ac-4a2b-41f4-b3fc-f1720dd20f48"

url_msstream_time <-
  "https://web.microsoftstream.com/video/ae21b0ac-4a2b-41f4-b3fc-f1720dd20f48?st=10"

list_parse_msstream <- list(
  service = "msstream",
  id = "ae21b0ac-4a2b-41f4-b3fc-f1720dd20f48",
  start_time = NULL
)

list_parse_msstream_time <- list(
  service = "msstream",
  id = "ae21b0ac-4a2b-41f4-b3fc-f1720dd20f48",
  start_time = "10"
)

list_suggest_msstream_time <- list(
  embed = "embed_msstream(\"ae21b0ac-4a2b-41f4-b3fc-f1720dd20f48\")",
  start_time = "use_start_time(\"10\")"
)

####
url_cran <- "https://cran.rstudio.com/"

####
expect_service <- function(url, service) {
  expect_identical(get_service(url), service)
}

expect_parse <- function(url, list_parse) {
  expect_identical(parse_video_url(url), list_parse)
}

expect_build <- function(list_parse, list_suggest) {
  expect_identical(build_suggestion(list_parse), list_suggest)
}

test_that("get_service works", {
  expect_service(url_youtube, "youtube")
  expect_service(url_youtube_short_time, "youtube_short")
  expect_service(url_vimeo_time, "vimeo")
  expect_service(url_channel9, "channel9")
  expect_service(url_user2016, "channel9")
  expect_service(url_user2017, "channel9")
  expect_service(url_box, "box")
  expect_service(url_box_acme, "box")
  expect_service(url_msstream, "msstream")
  expect_error(get_service(url_cran), regexp = "cran\\.rstudio\\.com")
})

test_that("parse_video_url works", {
  expect_parse(url_youtube, list_parse_youtube)
  expect_parse(url_youtube_short_time, list_parse_youtube_short_time)
  expect_parse(url_vimeo_time, list_parse_vimeo_time)
  expect_parse(url_channel9, list_parse_channel9)
  expect_parse(url_user2016, list_parse_user2016)
  expect_parse(url_user2017, list_parse_user2017)
  expect_parse(url_box, list_parse_box)
  expect_parse(url_box_acme, list_parse_box_acme)
  expect_parse(url_msstream, list_parse_msstream)
  expect_parse(url_msstream_time, list_parse_msstream_time)
  expect_error(parse_video_url(url_cran), regexp = "cran\\.rstudio\\.com")
})

test_that("build_suggestion works", {
  expect_build(list_parse_youtube, list_suggest_youtube)
  expect_build(list_parse_youtube_short_time, list_suggest_youtube_short_time)
  expect_build(list_parse_vimeo_time, list_suggest_vimeo_time)
  expect_build(list_parse_channel9, list_suggest_channel9)
  expect_build(list_parse_user2016, list_suggest_user2016)
  expect_build(list_parse_user2017, list_suggest_user2017)
  expect_build(list_parse_box, list_suggest_box)
  expect_build(list_parse_box_acme, list_suggest_box_acme)
  expect_build(list_parse_msstream_time, list_suggest_msstream_time)
})

context("test-div")

library("conflicted")
library("htmltools")

test_that("embed functions set a ratio", {

  ratio <- function(x) {
    attr(x, "ratio")
  }

  expect_identical(ratio(rickroll_youtube()), "16by9")
  expect_identical(ratio(rickroll_vimeo()), "16by9")
  expect_identical(ratio(embed_box("foo")), "16by9")
})

test_that("use_align() works", {

  emb <- rickroll_youtube()
  emb_new <- use_align(emb, "center")

  expect_error(use_align(emb, "down"))

  expect_is(emb_new, class(emb))
  expect_identical(get_iframe(emb), get_iframe(emb_new))
  expect_identical(emb_new$attribs$align, "center")
})

test_that("use_bs_responsive() works", {

  emb <- rickroll_youtube(ratio = "4by3")
  emb_new <- use_bs_responsive(emb)

  expect_error(use_align(emb, "down"))

  expect_is(emb_new, class(emb))

  expect_identical(
    tagGetAttribute(emb_new, "class"),
    "vembedr embed-responsive embed-responsive-4by3"
  )

  expect_identical(
    tagGetAttribute(get_iframe(emb_new), "class"),
    "embed-responsive-item"
  )
})

test_that("use_rounded() works", {

  emb <- rickroll_youtube()
  emb_standard <- use_rounded(emb)
  emb_user <- use_rounded(emb, 10)

  # iframe remains unchanged
  expect_identical(get_iframe(emb), get_iframe(emb_standard))

  # we have attached the html dependency
  expect_true(is.list(attr(emb_standard, "html_dependencies")))

  # the interior div has right class
  expect_identical(
    htmltools::tagGetAttribute(emb_standard[["children"]][[1]], "class"),
    "vembedr-rounded"
  )

  # setting the radius
  expect_identical(
    htmltools::tagGetAttribute(emb_user[["children"]][[1]], "style"),
    "border-radius: 10px;"
  )

})

context("use_start_time")

youtube <- rickroll_youtube()
youtube_start <- use_start_time(youtube, "25s")

get_query <- function(embed) {
  iframe <- get_iframe(embed)
  src <- htmltools::tagGetAttribute(iframe, "src")
  url <- httr::parse_url(src)

  url$query
}

test_that("youtube works", {
  expect_identical(get_query(youtube_start), list(start="25"))
})

vimeo <- rickroll_vimeo()
vimeo_start <- use_start_time(vimeo, "1m3s")

get_fragment <- function(elem) {
  iframe <- get_iframe(elem)
  src <- htmltools::tagGetAttribute(iframe, "src")
  url <- httr::parse_url(src)

  url$fragment
}

test_that("vimeo works", {
  expect_identical(get_fragment(vimeo_start), "t=63")
})

test_that("box throws a warning", {

  emb_box <- embed_box("foo")

  expect_warning(use_start_time(emb_box, "25s"), "^Start time")
})

test_that("msstream works", {

  emb_msstream <- embed_msstream("foo") %>% use_start_time(10)

  expect_identical(
    get_query(emb_msstream)[["st"]],
    "10"
  )

})

context("secs-hms")


test_that(".secs function works", {
  expect_equal(.secs("15"), 15)
  expect_equal(.secs("15s"), 15)
  expect_equal(.secs("1m"), 60)
  expect_equal(.secs("3m15s"), 195)
  expect_equal(.secs("1h3m15s"), 3795)
})

test_that(".hms function works", {
  expect_identical(.hms(3810), "1h3m30s")
  expect_identical(.hms("3810"), "1h3m30s")
  expect_identical(.hms("3m15s"), "0h3m15s")
  expect_identical(.hms("3m"), "0h3m0s")
})
